"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.4.1
(function () {
  var DeadletterProcessor,
      MapperToSearch,
      MaxRetriesProcessor,
      Repository,
      _,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  _ = require("lodash");

  Repository = require("./repository");

  MapperToSearch = require("./mapper");

  var _require = require("notification-processor");

  MaxRetriesProcessor = _require.Processors.MaxRetriesProcessor;


  module.exports = DeadletterProcessor = function (_MaxRetriesProcessor) {
    _inherits(DeadletterProcessor, _MaxRetriesProcessor);

    function DeadletterProcessor(opts) {
      _classCallCheck(this, DeadletterProcessor);

      var _this = _possibleConstructorReturn(this, (DeadletterProcessor.__proto__ || Object.getPrototypeOf(DeadletterProcessor)).call(this, opts));

      _this._shouldRetry_ = _this._shouldRetry_.bind(_this);
      _this.mapper = new MapperToSearch(opts);
      _this.repository = new Repository(opts);
      return _this;
    }

    _createClass(DeadletterProcessor, [{
      key: "_onSuccess_",
      value: function _onSuccess_(notification, result) {}
    }, {
      key: "_shouldRetry_",
      value: function _shouldRetry_(notification, err) {
        var ref, ref1, statusCode;
        boundMethodCheck(this, DeadletterProcessor);
        statusCode = err != null ? (ref = err.detail) != null ? (ref1 = ref.response) != null ? ref1.statusCode : void 0 : void 0 : void 0;
        return _get(DeadletterProcessor.prototype.__proto__ || Object.getPrototypeOf(DeadletterProcessor.prototype), "_shouldRetry_", this).call(this, notification, err) || statusCode >= 500;
      }
    }, {
      key: "_sanitizeError_",
      value: function _sanitizeError_(err) {
        return err;
      }
    }, {
      key: "_onMaxRetryExceeded_",
      value: function _onMaxRetryExceeded_(notification, err) {
        return this.repository.save(this.mapper.map(notification, err));
      }
    }]);

    return DeadletterProcessor;
  }(MaxRetriesProcessor);
}).call(undefined);